/*
	MON80 Version 2.1 - 8080 Monitor Program
	Language: Small-C + ASM on CP/M
	(C)1996-2006 Office TETSU
*/
main()
{
	char *adrbgn, *adrend;
	char combuf[80], com[80], rdo[80], par0[80], par1[80], par2[80];

	adrbgn = 0x8000;
	*combuf = *com = *rdo = *par0 = *par1 = *par2 = 0;

	putnwl();
	putstr("MON80 Version 2.1 CP/M Edition"); putnwl();
	putstr("Intel8080 Monitor Program"); putnwl();
	putstr("(C)1996-2006 Office TETSU"); putnwl();
	putnwl();

	while(1){
	asmpmt(adrbgn);
	getstr(combuf, 73);
	toustr(combuf);
	setcmd(combuf, com, par0);
	setpar(par0, par1, par2);
	if(*combuf != 0) strcpy(rdo, com);

	if(strcmp(rdo, "LIST") == 0){
		if(isxstr(par1)) adrbgn = xtoi(par1);
		if(isxstr(par2)) adrend = xtoi(par2);
			else adrend = adrbgn + 16;
		adrbgn = discod(adrbgn, adrend);}
	else
	if(strcmp(rdo, "DUMP") == 0){
		if(isxstr(par1)) adrbgn = xtoi(par1);
		if(isxstr(par2)) adrend = xtoi(par2);
			else adrend = adrbgn;
		adrbgn = dmpcod(adrbgn, adrend);}
	else	if(*com == 0);
	else	if(strcmp(com, "SYSTEM" ) == 0) system();
	else	if(strcmp(com, "HELP"  ) == 0) dsphlp(par0);
	else	if(strcmp(com, "GOSUB" ) == 0)
			if(isxstr(par1)) gosub(xtoi(par1));
		else{	putstr("ERROR-");putstr(par1);putnwl();}
	else	if(strcmp(com, "DEFINE") == 0)
		adrbgn = define(adrbgn, par0);
	else	if(isxstr(com)) adrbgn = xtoi(com);
	else	adrbgn = asmlin(adrbgn, com, par1, par2);
	}
}

discod(char *s, char *e)
{
	do{ s = dislin(s);} while(s <= e);
	return(s);
}

dislin(char *s)
{
	char mcod;
	int *w;

	putchr(' ');
	putwrd(s);
	putchr(' ');
	mcod = *s++;
	putstr(opecod(mcod));
		w = s;
		if(*operd1(mcod) == 1){putchr('\t'); putbyt(*s); s += 1;}
	else	if(*operd1(mcod) == 2){putchr('\t'); putwrd(*w); s += 2;}
	else	if(*operd1(mcod) != 0){putchr('\t'); putstr(operd1(mcod));}
	else	{putnwl(); return(s);}
		w = s;
		if(*operd2(mcod) == 1){putchr(','); putbyt(*s); s += 1;}
	else	if(*operd2(mcod) == 2){putchr(','); putwrd(*w); s += 2;}
	else	if(*operd2(mcod) != 0){putchr(','); putstr(operd2(mcod));}
	putnwl( );
	return(s);
}

dmpcod(char *s, char *e)
{
	putstr("      ");
	putstr("+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F ");
	putstr("ASCII");
	putnwl();

	s = s & 0xfff0;
	do{ s = dmplin(s);} while((s - 1) < e);
	return(s);
}

dmplin(char *s)
{
	char buf[16];
	int i;

	putchr(' ');
	putwrd(s);
	putchr(' ');
	for(i = 0; i < 16; i++) buf[i] = *s++;
	for(i = 0; i < 16; i++){
		putbyt(buf[i]);
		putchr(' ');}
	for(i = 0; i < 16; i++){
		if(isprint(buf[i])) putchr(buf[i]);
		else putchr('.');}
	putnwl();
	return(s);
}

define(char *s, char *l)
{
	char buf[80], *t;

	while(*l){
	setpar(l, buf, l);
		t = buf;
		if(isxstr(t)) *s++ = xtob(t);
	else	if(*t == 39){t++; while(*t && (*t != 39)){*s++ = *t++;}}
	else{	putstr("Error-");
		putstr(buf);
		putnwl();
		break;}
	}
	return(s);
}

dsphlp(char *s)
{
	char *t;
	int i, ok;

	if(*s == 0){
	putstr("      xxxx     Change current address"); putnwl();
	putstr("      mnemonic Assemble"); putnwl();
	putstr("      LIST     Disassemble"); putnwl();
	putstr("      DEFINE   Define data"); putnwl();
	putstr("      DUMP     Display data"); putnwl();
	putstr("      GOSUB    Call subroutine"); putnwl();
	putstr("      HELP     Display help"); putnwl();
	putstr("      SYSTEM   Return system"); putnwl();
	} else {
	while(*s != 0 && (isspace(*s) || *s == ',')) s++; t = s;
	while(*t != 0 && !isspace(*t) &&  *t != ',') t++;*t = 0;

	ok = 0;
	for(i = 0; i <= 255; i++){
	if(strcmp(s, opecod(i)) == 0){
	putstr("      "); putstr(opecod(i));
		if(*operd1(i) == 1)  {	putchr('\t'); putstr("xx");}
	else	if(*operd1(i) == 2)  {	putchr('\t'); putstr("xxxx");}
	else	if(*operd1(i) != 0)  {	putchr('\t'); putstr(operd1(i));}
		if(*operd2(i) == 1)  {	putchr(',') ; putstr("xx");}
	else	if(*operd2(i) == 2)  {	putchr(',') ; putstr("xxxx");}
	else	if(*operd2(i) != 0)  {	putchr(',') ; putstr(operd2(i));}
	putnwl();
	ok = 1;}}

	if(ok == 0){putstr("ERROR-"); putstr(s); putnwl();}
	}
}

asmlin(char *s, char *cd, char *r1, char *r2)
{
	char i;
	int *w, ok;

	i = 255; ok = 0;
	while(i-- && (ok == 0)){
	if (strcmp(cd, opecod(i)) == 0)
	if((strcmp(r1, operd1(i)) == 0) || (isxstr(r1) && (*operd1(i) <= 2)))
	if((strcmp(r2, operd2(i)) == 0) || (isxstr(r2) && (*operd2(i) <= 2)))
	ok = 1;}

	if(ok == 0){
	putstr("ERROR-");
	putstr(cd); putchr(' ');
	if(*r1 != 0) putstr(r1);
	if(*r2 != 0){putchr(','); putstr(r2);}
	putnwl();
	return(s);
	}

		i++; *s++ = i; w = s;
		if(*operd1(i) == 1){*s = xtob(r1); s += 1;}
	else	if(*operd2(i) == 1){*s = xtob(r2); s += 1;}
	else	if(*operd1(i) == 2){*w = xtoi(r1); s += 2;}
	else	if(*operd2(i) == 2){*w = xtoi(r2); s += 2;}
	return(s);
}

asmpmt(char *p) {putchr('['); putwrd(p); putchr(']');}

setcmd(char *buf, char *com, char *par)
{
	while(*buf != 0 && (isspace(*buf) || *buf == ',')) buf++;
	while(*buf != 0 && !isspace(*buf) && *buf != ',') *com++ = *buf++;
	*com = 0;
	while(*buf != 0 && *buf == ' ') buf++;
	while(*buf != 0) *par++ = *buf++;
	*par = 0;
}

setpar(char *buf, char *par1, char *par2)
{
	while(*buf != 0 && *buf == ' ') buf++;
	while(*buf != 0 && *buf != ',') *par1++ = *buf++;
	*par1 = 0;
	if   (*buf != 0 && *buf == ',') buf++;
	while(*buf != 0 && *buf == ' ') buf++;
	while(*buf != 0) *par2++ = *buf++;
	*par2 = 0;
}

toupper(char c) {return(c <= 'z' && c >= 'a' ? c - 32 : c);}
toustr(char *b) {while(*b){*b = toupper(*b); b++;}}
isprint(char c) {return(c >= 32  && c <= 126);}
isspace(char c) {return(c <= ' ' &&(c == ' ' || (c <= 13 && c >= 9)));}

isxdigit(char c)
{
	return	(
	(c<='f' && c>='a') || (c<='F' && c>='A') || (c<='9' && c>='0'));
}

isxstr(char *s)
{
	if((*s == 0) || (strcmp(s, "ADC") == 0)) return(0);
	if((strcmp(s, "ADD") == 0) || (strcmp(s, "CC") == 0)) return(0); 
	if((strcmp(s, "DAA") == 0) || (strcmp(s, "DAD") == 0)) return(0);
	while(isxdigit(*s)) s++;
	if(*s == 0)	return(1);
		 else return(0);
}

strcpy(char *s, char *t) {while(*s++ = *t++);}

strcmp(char *s, char *t)
{
	while(*s == *t) {
	if(*s == 0) return (0);
	++s; ++t;
	}
	return (*s - *t);
}

itoa(int value, char *buffer)
{
	int x, y;
	char sign;
	char temp[8];

	for(x = 0; x < 8; x ++) temp[x] = ' ';
	sign = (value >= 0) ? '+' : '-';
	x = 7;
	do {
		temp[x] = (value % 10) + '0';
		value = value / 10;
		x--;
	} while(value > 0);
	temp[x] = sign;
	y = 0;
	while(x < 8) buffer[y++] = temp[x++];
	buffer[y] = '\0';
}

atoi(char *s)
{
	int n, sign;
	sign=n=0;
	if(*s == '+' || *s == '-') /* sign */
		if(*s++ == '-') sign = -sign;
	while(*s)
		n = 10 * n + *s++ - '0';
	if(sign) return(-n);
	return n;
}

xtob(char *s)
{
	char n, t;

	n = 0;
	while(*s != 0){
	     if((*s >= '0') && (*s <='9'))  t = 48;
	else if((*s >= 'A') && (*s <= 'F')) t = 55;
	else if((*s >= 'a') && (*s <= 'f')) t = 87;
	else break;
	n = (n << 4) + *s - t;
	s++;
	}
	return n;
}

xtoi(char *s)
{
	int n, t;

	n = 0;
	while(*s != 0){
	     if((*s >= '0') && (*s <='9'))  t = 48;
	else if((*s >= 'A') && (*s <= 'F')) t = 55;
	else if((*s >= 'a') && (*s <= 'f')) t = 87;
	else break;
	n = (n << 4) + *s - t;
	s++;
	}
	return n;
}

putnwl( ) {putstr("\15\12");}

putwrd(int n)
{
	char c, buf[5];
	int i;

	for(i = 3; i >= 0; i--){
		c = n & 15;
		n = (n >> 4 ) & 4095;
		if(c < 10) buf[i] = c + 48;
		      else buf[i] = c + 55;
	}
	buf[4] = 0;
	putstr(buf);
}

putbyt(char n)
{
	char c, buf[3];
	int i;

	for(i = 1; i >= 0; i--){
		c = n & 15;
		n = (n >> 4 ) & 4095;
		if(c < 10) buf[i] = c + 48;
		      else buf[i] = c + 55;
	}
	buf[2] = 0;
	putstr(buf);
}

putstr(char *b) {while(*b) putchr(*b++);}

getstr(char buf[], int max)
{
	char ch;
	int len;

	len = 0;
	while((ch = getchr()) != 13){
	if( ch == 9) ch = ' ';
	if((ch == 8) && (len > 0)){
		len--;
		putchr(8); putchr(' '); putchr(8);}
	else if(isprint(ch) && (len < max)){
		buf[len++] = ch;
		putchr(ch);}
	}
	buf[len] = 0;
	putnwl();
}

gosub(char *address)
{
#asm
	POP	B
	POP	D
	PUSH	D
	PUSH	B
	LXI	H,ADRRET
	PUSH	H
	XCHG
	PCHL
ADRRET:
#endasm
}

putchr(char ch)
{
#asm
	POP	B
	POP	D
	PUSH	D
	PUSH	B
	MVI	C,02H
	CALL	0005H
#endasm
}

getchr()
{
#asm
GCLOOP:
	MVI	C,06H
	MVI	E,0FFH
	CALL	0005H
	CPI	00H
	JZ	GCLOOP
	MVI	H,00H
	MOV	L,A
#endasm
}

system()
{
#asm
	MVI	C,00H
	CALL	0005H
#endasm
}

opecod(int cod)
{
#asm
	POP	D
	POP	B
	PUSH	B
	PUSH	D
	LXI	D,OPCPTR
	MVI	H,00H
	MOV	L,C
	DAD	H
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	RET
;
OPC001:	DB	'?',00H
OPC002:	DB	'A','C','I',00H
OPC003:	DB	'A','D','C',00H
OPC004:	DB	'A','D','D',00H
OPC005:	DB	'A','D','I',00H
OPC006:	DB	'A','N','A',00H
OPC007:	DB	'A','N','I',00H
OPC008:	DB	'C','A','L','L',00H
OPC009:	DB	'C','C',00H
OPC010:	DB	'C','M',00H
OPC011:	DB	'C','M','A',00H
OPC012:	DB	'C','M','C',00H
OPC013:	DB	'C','M','P',00H
OPC014:	DB	'C','N','Z',00H
OPC015:	DB	'C','P',00H
OPC016:	DB	'C','P','E',00H
OPC017:	DB	'C','P','I',00H
OPC018:	DB	'C','P','O',00H
OPC019:	DB	'C','Z',00H
OPC020:	DB	'D','A','A',00H
OPC021:	DB	'D','A','D',00H
OPC022:	DB	'D','C','R',00H
OPC023:	DB	'D','C','X',00H
OPC024:	DB	'D','I',00H
OPC025:	DB	'E','I',00H
OPC026:	DB	'H','L','T',00H
OPC027:	DB	'I','N',00H
OPC028:	DB	'I','N','R',00H
OPC029:	DB	'I','N','X',00H
OPC030:	DB	'J','C',00H
OPC031:	DB	'J','C','Z',00H
OPC032:	DB	'J','M',00H
OPC033:	DB	'J','M','P',00H
OPC034:	DB	'J','N','Z',00H
OPC035:	DB	'J','P',00H
OPC036:	DB	'J','P','E',00H
OPC037:	DB	'J','P','O',00H
OPC038:	DB	'J','Z',00H
OPC039:	DB	'L','D','A',00H
OPC040:	DB	'L','D','A','X',00H
OPC041:	DB	'L','H','L','D',00H
OPC042:	DB	'L','X','I',00H
OPC043:	DB	'M','O','V',00H
OPC044:	DB	'M','V','I',00H
OPC045:	DB	'N','O','P',00H
OPC046:	DB	'O','R','A',00H
OPC047:	DB	'O','R','I',00H
OPC048:	DB	'O','U','T',00H
OPC049:	DB	'P','C','H','L',00H
OPC050:	DB	'P','O','P',00H
OPC051:	DB	'P','U','S','H',00H
OPC052:	DB	'R','A','L',00H
OPC053:	DB	'R','A','R',00H
OPC054:	DB	'R','C',00H
OPC055:	DB	'R','E','T',00H
OPC056:	DB	'R','L','C',00H
OPC057:	DB	'R','M',00H
OPC058:	DB	'R','N','C',00H
OPC059:	DB	'R','N','Z',00H
OPC060:	DB	'R','P',00H
OPC061:	DB	'R','P','E',00H
OPC062:	DB	'R','P','O',00H
OPC063:	DB	'R','R','C',00H
OPC064:	DB	'R','S','T','0',00H
OPC065:	DB	'R','S','T','1',00H
OPC066:	DB	'R','S','T','2',00H
OPC067:	DB	'R','S','T','3',00H
OPC068:	DB	'R','S','T','4',00H
OPC069:	DB	'R','S','T','5',00H
OPC070:	DB	'R','S','T','6',00H
OPC071:	DB	'R','S','T','7',00H
OPC072:	DB	'R','Z',00H
OPC073:	DB	'S','B','B',00H
OPC074:	DB	'S','B','I',00H
OPC075:	DB	'S','H','L','D',00H
OPC076:	DB	'S','P','H','L',00H
OPC077:	DB	'S','T','A',00H
OPC078:	DB	'S','T','A','X',00H
OPC079:	DB	'S','T','C',00H
OPC080:	DB	'S','U','B',00H
OPC081:	DB	'S','U','I',00H
OPC082:	DB	'X','C','H','G',00H
OPC083:	DB	'X','R','A',00H
OPC084:	DB	'X','R','I',00H
OPC085:	DB	'X','T','H','L',00H
;
OPCPTR:
	DW	OPC045,OPC042,OPC078,OPC029,OPC028,OPC022,OPC044,OPC056
	DW	OPC001,OPC021,OPC040,OPC023,OPC028,OPC022,OPC044,OPC063
	DW	OPC001,OPC042,OPC078,OPC029,OPC028,OPC022,OPC044,OPC052
	DW	OPC001,OPC021,OPC040,OPC023,OPC028,OPC022,OPC044,OPC053
	DW	OPC001,OPC042,OPC075,OPC029,OPC028,OPC022,OPC044,OPC020
	DW	OPC001,OPC021,OPC041,OPC023,OPC028,OPC022,OPC044,OPC011
	DW	OPC001,OPC042,OPC077,OPC029,OPC028,OPC022,OPC044,OPC079
	DW	OPC001,OPC021,OPC039,OPC023,OPC028,OPC022,OPC044,OPC012
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC026,OPC043
	DW	OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043,OPC043
	DW	OPC004,OPC004,OPC004,OPC004,OPC004,OPC004,OPC004,OPC004
	DW	OPC003,OPC003,OPC003,OPC003,OPC003,OPC003,OPC003,OPC003
	DW	OPC080,OPC080,OPC080,OPC080,OPC080,OPC080,OPC080,OPC080
	DW	OPC073,OPC073,OPC073,OPC073,OPC073,OPC073,OPC073,OPC073
	DW	OPC006,OPC006,OPC006,OPC006,OPC006,OPC006,OPC006,OPC006
	DW	OPC083,OPC083,OPC083,OPC083,OPC083,OPC083,OPC083,OPC083
	DW	OPC046,OPC046,OPC046,OPC046,OPC046,OPC046,OPC046,OPC046
	DW	OPC013,OPC013,OPC013,OPC013,OPC013,OPC013,OPC013,OPC013
	DW	OPC059,OPC050,OPC034,OPC033,OPC014,OPC051,OPC005,OPC064
	DW	OPC072,OPC055,OPC038,OPC001,OPC019,OPC008,OPC002,OPC065
	DW	OPC058,OPC050,OPC031,OPC048,OPC014,OPC051,OPC081,OPC066
	DW	OPC054,OPC001,OPC030,OPC027,OPC009,OPC001,OPC074,OPC067
	DW	OPC062,OPC050,OPC037,OPC085,OPC018,OPC051,OPC007,OPC068
	DW	OPC061,OPC049,OPC036,OPC082,OPC016,OPC001,OPC084,OPC069
	DW	OPC060,OPC050,OPC035,OPC024,OPC015,OPC051,OPC047,OPC070
	DW	OPC057,OPC076,OPC032,OPC025,OPC010,OPC001,OPC017,OPC071
#endasm
}

operd1(int cod)
{
#asm
	POP	D
	POP	B
	PUSH	B
	PUSH	D
	LXI	D,OR1PTR
	MVI	H,00H
	MOV	L,C
	DAD	H
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	RET
;
OR1000:	DB	00H,00H
OR1001:	DB	01H,00H
OR1002:	DB	02H,00H
OR1003:	DB	'A',00H
OR1004:	DB	'B',00H
OR1005:	DB	'C',00H
OR1006:	DB	'D',00H
OR1007:	DB	'E',00H
OR1008:	DB	'H',00H
OR1009:	DB	'L',00H
OR1010:	DB	'M',00H
OR1011:	DB	'P','S','W',00H
OR1012:	DB	'S','P',00H
;
OR1PTR:
	DW	OR1000,OR1004,OR1004,OR1004,OR1004,OR1004,OR1004,OR1000
	DW	OR1000,OR1004,OR1004,OR1004,OR1005,OR1005,OR1005,OR1000
	DW	OR1000,OR1006,OR1006,OR1006,OR1006,OR1006,OR1006,OR1000
	DW	OR1000,OR1006,OR1006,OR1006,OR1007,OR1007,OR1007,OR1000
	DW	OR1000,OR1008,OR1002,OR1008,OR1008,OR1008,OR1008,OR1000
	DW	OR1000,OR1008,OR1002,OR1008,OR1009,OR1009,OR1009,OR1002
	DW	OR1000,OR1012,OR1002,OR1012,OR1010,OR1010,OR1010,OR1000
	DW	OR1000,OR1012,OR1002,OR1012,OR1003,OR1003,OR1003,OR1002
	DW	OR1004,OR1004,OR1004,OR1004,OR1004,OR1004,OR1004,OR1004
	DW	OR1005,OR1005,OR1005,OR1005,OR1005,OR1005,OR1005,OR1005
	DW	OR1006,OR1006,OR1006,OR1006,OR1006,OR1006,OR1006,OR1006
	DW	OR1007,OR1007,OR1007,OR1007,OR1007,OR1007,OR1007,OR1007
	DW	OR1008,OR1008,OR1008,OR1008,OR1008,OR1008,OR1008,OR1008
	DW	OR1009,OR1009,OR1009,OR1009,OR1009,OR1009,OR1009,OR1009
	DW	OR1010,OR1010,OR1010,OR1010,OR1010,OR1010,OR1000,OR1010
	DW	OR1003,OR1003,OR1003,OR1003,OR1003,OR1003,OR1003,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1004,OR1005,OR1006,OR1007,OR1008,OR1009,OR1010,OR1003
	DW	OR1000,OR1004,OR1002,OR1002,OR1000,OR1004,OR1001,OR1000
	DW	OR1000,OR1000,OR1002,OR1000,OR1000,OR1002,OR1001,OR1000
	DW	OR1000,OR1006,OR1002,OR1001,OR1000,OR1006,OR1001,OR1000
	DW	OR1000,OR1000,OR1002,OR1001,OR1002,OR1000,OR1001,OR1000
	DW	OR1000,OR1008,OR1002,OR1000,OR1000,OR1008,OR1001,OR1000
	DW	OR1000,OR1000,OR1002,OR1000,OR1000,OR1000,OR1001,OR1000
	DW	OR1000,OR1011,OR1002,OR1000,OR1000,OR1011,OR1001,OR1000
	DW	OR1000,OR1000,OR1002,OR1000,OR1002,OR1000,OR1001,OR1000
#endasm
}

operd2(int cod)
{
#asm
	POP	D
	POP	B
	PUSH	B
	PUSH	D
	LXI	D,OR2PTR
	MVI	H,00H
	MOV	L,C
	DAD	H
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	RET
;
OR2000:	DB	00H,00H
OR2001:	DB	01H,00H
OR2002:	DB	02H,00H
OR2003:	DB	'A',00H
OR2004:	DB	'B',00H
OR2005:	DB	'C',00H
OR2006:	DB	'D',00H
OR2007:	DB	'E',00H
OR2008:	DB	'H',00H
OR2009:	DB	'L',00H
OR2010:	DB	'M',00H
OR2011:	DB	'P','S','W',00H
OR2012:	DB	'S','P',00H
;
OR2PTR:
	DW	OR2000,OR2002,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2002,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2002,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2002,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2001,OR2000
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2000,OR2003
	DW	OR2004,OR2005,OR2006,OR2007,OR2008,OR2009,OR2010,OR2003
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
	DW	OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000,OR2000
#endasm
}
